#include <stdio.h>
#include <string.h>
#include "rfs.h"
#include "ex-rfs.h"

static rf_int_t write_sector_buf(rf_char_t* file)
{
    rf_char_t* sector_buf;
    rf_int_t ret, fd, sector_len, i;
    rf_ssize_t len;

    sector_buf = rf_get_volume_sector_buf(file);
    sector_len = rf_get_volume_sector_size(file);

    fd = rf_open(file, RF_O_CREAT | RF_O_RDWR | RF_O_TRUNC | RF_O_SECBUF);
    check_ret_error_stop("rf_open", fd);
    for (i = 0; i < 600; i++) {
        memset(sector_buf, 0x30 + i, sector_len);
        len = rf_write(fd, sector_buf, sector_len);
        check_ssize_error_stop("rf_write", len);

        /*rf_write len ÿηسΪд볤 ̿ռʱ سСд볤 */
        if (len < sector_len) {
            printf("Disk space full error\n");
            break;
        }

        /* ʱдļ rf_sync ļ */
        ret = rf_fsync(fd);
        check_ret_error_stop("rf_fsync", ret);
    }
    ret = rf_close(fd);
    check_ret_error_stop("rf_close", ret);
    return 0;
}

static rf_int_t read_sector_buf(rf_char_t* file)
{
    rf_char_t* sector_buf;
    rf_int_t ret, fd, sector_len, i;
    rf_ssize_t len;

    sector_buf = rf_get_volume_sector_buf(file);
    sector_len = rf_get_volume_sector_size(file);

    fd = rf_open(file, RF_O_RDONLY | RF_O_SECBUF);
    check_ret_error_stop("rf_open", fd);
    for (i = 0; i < 600; i++) {
        len = rf_read(fd, sector_buf, sector_len);
        check_ssize_error_stop("rf_read", len);
    }

    ret = rf_close(fd);
    check_ret_error_stop("rf_close", ret);
    return 0;
}

rf_int_t sector_read_ex(rf_void_t)
{
    write_sector_buf("\\aabbb.txt");
    read_sector_buf("\\aabbb.txt");
    return 0;
}
