#include <stdio.h>
#include "rfs.h"
#include "ex-rfs.h"

int ex_statfile()
{
    rf_int_t ret;
    rf_int_t fd;
    rf_stat_t st;
    rf_tm_t create, last_write, last_access;

    fd = rf_open("\\1.txt", RF_O_RDONLY);
    check_ret_error_stop("rf_open", fd);

    ret = rf_fstat(fd, &st);
    check_ret_error_stop("rf_fstat", ret);
    ret = rf_get_ltime(fd, &create, &last_access, &last_write);
    check_ret_error_stop("rf_get_time", ret);

    /* ļ rfs.h ͷļ */
    printf("attribute=0x%x\n", st.st_mode);
    /* ǰļƫ */
    printf("current_offset=0x%d\n", st.current_offset);
    /* ļС */
    printf("size=0x%x\n", st.st_size);
    /* ļʱϢ */
    printf("create: %04d%02d%02d-%02d:%02d:%02d\n",
           create.tm_year, create.tm_mon, create.tm_mday,
           create.tm_hour, create.tm_min, create.tm_sec);
    printf("last_write: %04d%02d%02d-%02d:%02d:%02d\n",
           last_write.tm_year, last_write.tm_mon, last_write.tm_mday,
           last_write.tm_hour, last_write.tm_min, last_write.tm_sec);
    printf("last_access: %04d%02d%02d-%02d:%02d:%02d\n",
           last_access.tm_year, last_access.tm_mon, last_access.tm_mday,
           last_access.tm_hour, last_access.tm_min, last_access.tm_sec);
    rf_close(fd);
    return 0;
}

int ex_timefile()
{
    rf_int_t ret;
    rf_int_t fd;
    rf_tm_t create, last_write, last_access;

    fd = rf_open("\\1.txt", RF_O_RDONLY);
    check_ret_error_stop("rf_open", fd);

    /* ļʱ */
    create.tm_year = 2015;
    create.tm_mon = 10;
    create.tm_mday = 1;
    create.tm_hour = 10;
    create.tm_min = 10;
    create.tm_sec = 50;

    last_write.tm_year = 2015;
    last_write.tm_mon = 10;
    last_write.tm_mday = 1;
    last_write.tm_hour = 10;
    last_write.tm_min = 10;
    last_write.tm_sec = 56;

    last_access.tm_year = 2015;
    last_access.tm_mon = 10;
    last_access.tm_mday = 2;
    last_access.tm_hour = 10;
    last_access.tm_min = 10;
    last_access.tm_sec = 40;

    ret = rf_set_ltime(fd, &create, &last_access, &last_write);
    check_ret_error_stop("rf_set_time", ret);
    rf_close(fd);
    return 0;
}