#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rfs.h"
#include "ex-rfs.h"

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

/* ļ ڿдļ */
int truncate_ex(rf_char_t* file)
{
    rf_int_t ret;
    rf_int_t fd, i;
    rf_statfs_t st;
    rf_off_t len, tmp, buf_len;
    rf_void_t* p;
    rf_ssize_t size;
#if !RF_OPT_USE_MALLOC
    rf_u8_t buf[31];
#endif

    /* 򿪵ǰµıļ */
    fd = rf_open(file, RF_O_CREAT | RF_O_RDWR | RF_O_TRUNC);
    check_ret_error_stop("rf_open", fd);

    ret = rf_statfs("a:", &st);
    check_ret_error_stop("rf_statfs", ret);

    /* u̿ÿռ ļС */
#if RF_OPT_USE_MALLOC
    len = st.f_ssize * st.sectors_per_cluster * (st.f_bfree - 1);
#else
    len = 1024 * 100 + 33;
#endif
    ret = rf_ftruncate(fd, len);
    check_ret_error_stop("rf_ftruncate", ret);

    /* ļ */
    ret = rf_fsync(fd);
    check_ret_error_stop("rf_fsync", ret);

#if RF_OPT_USE_MALLOC
    /* ÿд뻺Խ дٶԽ */
    buf_len = 10 * 1024 * 1024;
    p = malloc(buf_len);
#else
    buf_len = sizeof(buf);
    p = buf;
#endif
    /* ʼ */
    for (i = 0; i < buf_len; i++)
        *((rf_u8_t*)p + i) = 'a';

    /* дļ */
    tmp = 0;
    for (;;) {
        i = min(len - tmp, buf_len);
        if (!i)
            break;
        tmp += i;
        printf("tmp=%d len=%d\n", tmp, len);

        size = rf_write(fd, p, i);
        check_ssize_error_stop("rf_write", size);
    }

    ret = rf_close(fd);
    check_ret_error_stop("rf_close", ret);
    return 0;
}

rf_int_t rm_file_ex(rf_char_t* file)
{
    rf_int_t ret;
    ret = rf_unlink(file);
    check_ret_error_stop("rf_unlink", ret);
    return 0;
}