/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_CHAIN_H__
#define __RF_CHAIN_H__

typedef struct {
    /* ʼغ*/
    rf_u32_t cluster;
    /* ˴غſʼмĴ*/
    rf_u32_t number;
} rf_chain_t, *rf_chain_ref_t;

struct _rf_chain_idx_t {
    /* ڸļĿ¼һ */
    rf_u8_t             last_chain_index;
    /* ڵǰ */
    rf_u8_t             chain_offset;
    /* ¼ǰȡƫ */
    rf_u8_t             sector_offset;
    /* ֽڷʽʱ,ڵǰƫ */
    rf_u16_t            byte_offset;
    /* صƫ */
    rf_u32_t            cluster_offset;
    /* Ż */
    rf_chain_t          chain[RF_MAX_CHAIN_LENGTH];
};
typedef struct _rf_chain_idx_t rf_chain_idx_t, *rf_chain_idx_ref_t;

void chain_init(rf_chain_idx_t* clust, rf_int_t all);
void chain_offset_next_cluster(rf_chain_idx_t* clust);

rf_u32_t chain_get_last_clust(rf_chain_idx_t* clust);
rf_u32_t chain_count_clust(rf_chain_idx_t* clust);

rf_int_t chain_offset_sector(rf_chain_idx_t* clust, rf_int_t sector_per_clst, rf_u32_t offset);
rf_int_t chain_back_offset_sector(rf_chain_idx_t* clust, rf_int_t sector_per_clst, rf_u32_t offset);

#endif