/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __FAT_H__
#define __FAT_H__

#define FILE_DELETED        ((rf_u8_t)0XE5)
#define FILE_EMPTY          ((rf_u8_t)0X00)
#define F_DELETE_FAT        0X00
#define F_DESIGN_FAT        0X01

rf_int_t clusters_gather_file(rf_fat_file_ref_t file, rf_bool_t first_gather);
rf_int_t clusters_back_offset_sector(rf_fat_file_ref_t file, rf_u32_t count);
rf_int_t clusters_offset_sector(rf_fat_file_ref_t file, rf_u32_t count);
rf_int_t clusters_file_read(rf_fat_file_ref_t file, rf_u32_t read_sector, rf_u32_t* pread_sector, rf_u8_t* buf);

rf_int_t clusters_gather_empty(rf_fat_file_ref_t file, rf_u32_t number_clst, rf_u32_ref_t pnumber_clst, rf_bool_t gather);

rf_int_t _clusters_write(rf_fat_file_ref_t file, rf_u32_t begin_cluster, rf_u32_t number, rf_u32_t* last_cluster, rf_bool_t mode);
rf_int_t clusters_file_build_end(rf_fat_file_ref_t file, rf_u32_t count_sector, rf_u32_t* pcount_sector);
rf_int_t clusters_file_delete(rf_fat_file_ref_t file);
rf_int_t clusters_file_write_sector(rf_fat_file_ref_t file, rf_u8_t* buf, rf_u32_t count_sector, rf_u32_t* pcount_sector);

#endif /* end of include guard: __FAT_H__ */
