/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __FAT_VOLUME_H__
#define __FAT_VOLUME_H__

struct _rf_fat_volume_t {
    /* ļϵͳ */
    rf_u8_t fs_type: 4;
    /* 򿪱־ */
    rf_u8_t open_flag: 1;
    /*  ģʽ 0 1д */
    rf_u8_t access_flag: 1;
#if RF_OPT_FS_READONLY == 0
    /* µǰ־λ */
    rf_u8_t write_flag: 1;
    /* fsi־λ */
    rf_u8_t update_fsi_flag: 1;
#endif
#if RF_OPT_USE_MALLOC
    list_t list;
#endif
#if RF_OPT_USE_VOLUME_CTX
    rf_void_t* ctx;
#endif
    /* 豸ָ */
    rf_handle_t dev_handle;
#if RF_OPT_USE_MALLOC
    /*  */
    rf_u8_t* sector_buffer;
#else
    rf_u8_t sector_buffer[RF_OPT_MAX_SECTOR_SIZE];
#endif

    /* fat һؼ λ */
    rf_u8_t sectors_per_cluster_bits;
    /* ֽڵλ λ */
    rf_u8_t sector_size_bits;
    /* мfat */
    rf_u8_t bpb_num_fats;
    /* С */
    rf_u16_t sector_size;
    /* fat һؼ */
    rf_u16_t sectors_per_cluster;
    /* fat12/16 Ŀ¼ */
    rf_u16_t bpb_root_sector_size;

    /* жٸ */
    rf_u32_t bpb_total_clusters;
    /* 2: fat ʼ */
    rf_u32_t bpb_fat_start_sector;
    /* һfatռ */
    rf_u32_t bpb_fat_size;
    /* Ŀ¼ʼ */
    rf_u32_t bpb_root_start_sector;
    /* ݿʼ */
    rf_u32_t fat_data_start_sector;

    /* fat32 Ҫfsi־λ */
#if RF_OPT_FS_READONLY == 0
    /* fat32 fsinfo */
    rf_u32_t fat_fsinfo_sector;
#endif
    /* һô */
    rf_u32_t fat_fsi_nxt_free;
    /* жٸô */
    rf_u32_t fat_fsi_free_count;

    /* ǰĿ¼ */
    rf_fentry_t current_dir_entry;
    /* ǰȡ */
    rf_u32_t current_work_sector;
    /* ǰļϼĿ¼ ʼ */
    rf_u32_t updir_start_clst;
    /* ϼĿ¼ƫ */
    rf_u32_t updir_offset;
};
typedef struct _rf_fat_volume_t rf_fat_volume_t, *rf_fat_volume_ref_t;

rf_int_t fat_volume_open(rf_fat_volume_ref_t vol, rf_mount_param_t* param);
rf_int_t fat_volume_close(rf_fat_volume_ref_t vol);
rf_int_t fat_volume_stat(rf_fat_volume_ref_t vol, rf_statfs_ref_t pvs);
rf_int_t fat_volume_set_current_dir(rf_fat_volume_ref_t vol, rf_fentry_ref_t entry);
rf_int_t fat_volume_get_label(rf_fat_volume_ref_t vol, const rf_char_t* buf, rf_int_t len);
#if RF_OPT_FS_READONLY == 0
rf_int_t fat_volume_set_label(rf_fat_volume_ref_t vol, const rf_char_t* buf);
#endif

#endif
