/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_DOS_H__
#define __RF_DOS_H__

#define DOS_PART_DISKSIG_OFFSET     0x1b8
#define DOS_PART_TBL_OFFSET         0x1be
#define DOS_PART_MAGIC_OFFSET       0x1fe
#define DOS_PBR_FSTYPE_OFFSET       0x36
#define DOS_PBR32_FSTYPE_OFFSET     0x52
#define DOS_PBR_MEDIA_TYPE_OFFSET   0x15

#define DOS_PART_BOOT_IND_OFFSET    0
#define DOS_PART_SYS_IND_OFFSET     4
#define DOS_PART_START_OFFSET       8
#define DOS_PART_OFFSET_OFFSET      12

/* DOS partition types.  */
#define DOS_PARTITION_TYPE_NONE           0
#define DOS_PARTITION_TYPE_FAT12          1
#define DOS_PARTITION_TYPE_FAT16_LT32M    4
#define DOS_PARTITION_TYPE_EXTENDED       5
#define DOS_PARTITION_TYPE_FAT16_GT32M    6
#define DOS_PARTITION_TYPE_NTFS           7
#define DOS_PARTITION_TYPE_FAT32          0xb
#define DOS_PARTITION_TYPE_FAT32_LBA      0xc
#define DOS_PARTITION_TYPE_FAT16_LBA      0xe
#define DOS_PARTITION_TYPE_WIN95_EXTENDED 0xf
#define DOS_PARTITION_TYPE_PLAN9          0x39
#define DOS_PARTITION_TYPE_EZD            0x55
#define DOS_PARTITION_TYPE_MINIX          0x80
#define DOS_PARTITION_TYPE_LINUX_MINIX    0x81
#define DOS_PARTITION_TYPE_LINUX_SWAP     0x82
#define DOS_PARTITION_TYPE_EXT2FS         0x83
#define DOS_PARTITION_TYPE_LINUX_EXTENDED 0x85
#define DOS_PARTITION_TYPE_VSTAFS         0x9e
#define DOS_PARTITION_TYPE_FREEBSD        0xa5
#define DOS_PARTITION_TYPE_OPENBSD        0xa6
#define DOS_PARTITION_TYPE_NETBSD         0xa9
#define DOS_PARTITION_TYPE_HFS            0xaf
#define DOS_PARTITION_TYPE_GPT_DISK       0xee
#define DOS_PARTITION_TYPE_LINUX_RAID     0xfd

#endif
