/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifdef WIN32
#include <Windows.h>
#endif
#include "../include/rfs.h"
#include <stdio.h>

rf_void_t rf_assert_handler(const rf_char_t* file, rf_int_t line)
{
    printf("assertion failed at file:%s, line number:%d \n", file, line);
#ifdef WIN32
    DebugBreak();
    /*_asm { int 3 };*/
#else
    while (1);
#endif
}
