/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#include "../include/rfs.h"

#if RF_OPT_DYNAMIC_LIB == 1
rf_drv_open_t rf_disk_open;
rf_drv_close_t rf_disk_close;
rf_drv_ioctl_t rf_disk_ioctl;
rf_drv_read_t rf_disk_read;
#if RF_OPT_FS_READONLY == 0
rf_drv_write_t rf_disk_write;
#endif

rf_int_t rf_set_drv_func(rf_drv_ref_t drv)
{
    rf_disk_open = drv->open;
    rf_disk_close = drv->close;
    rf_disk_ioctl = drv->ioctl;
    rf_disk_read = drv->read;
#if RF_OPT_FS_READONLY == 0
    rf_disk_write = drv->write;
#endif
    return 0;
}
#endif

rf_int_t rf_getlocaltime(rf_tm_ref_t tm)
{
#if 0
    SYSTEMTIME sys;

    if (tm == NULL)
        return -1;
    GetLocalTime(&sys);

    tm->tm_sec = sys.wSecond;
    tm->tm_min = sys.wMinute;
    tm->tm_hour = sys.wHour;

    tm->tm_mday = sys.wDay;
    tm->tm_mon = sys.wMonth;
    tm->tm_year = sys.wYear;
#endif
    return 0;
}
