/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#include "../include/rfs.h"
#include "../common/rf_common.h"
#include "rf_fs.h"
#include "rf_file.h"

rf_int_t rf_stat(const rf_char_t* pathname, struct rf_stat* buf)
{
    rf_int_t fh;
    rf_int_t ret;

    fh = rf_open(pathname, RF_O_RDONLY);
    if (fh < 0)
        return -1;
    ret = rf_fstat(fh, (struct rf_stat_i*)buf);
    rf_close(fh);
    return ret;
}

rf_int_t rf_mkdir_p(const rf_char_t* path)
{
#if 0
    rf_char_t* pch;
    rf_char_t tmp[RF_MAX_PATH], tmp_path[RF_MAX_PATH] = {0};

    strncpy(tmp, path, sizeof(tmp));
    tmp[sizeof(tmp)] = '\0';
    pch = tmp;
    if (tmp[1] == ':') {
        tmp_path[0] = tmp[0];
        tmp_path[1] = tmp[1];
        tmp_path[2] = '\\';
        tmp_path[3] = 0x0;
        pch = tmp + 3;
    } else if (tmp[0] == '\\' || tmp[0] == '/')
        strcpy(tmp_path, "\\");

    /* 支持创建多级目录 */
    pch = strtok(pch, "\\/");
    while (pch != NULL) {
        strcat(tmp_path, pch);
        if (rf_mkdir(tmp_path) < 0)
            return -1;
        strcat(tmp_path, "\\");
        pch = strtok(NULL, "\\/");
    }
    return 0;
#endif
    return -1;
}
