/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RFS_FILE_H__
#define __RFS_FILE_H__

rf_int_t rf_file_raw_open(rf_file_ctx_t* fc, const rf_char_t* path, rf_fentry_t* fentry, rf_int_t flags);
rf_int_t rf_file_open(rf_file_ctx_t* fc, const rf_char_t* path, rf_int_t flags);
rf_int_t rf_file_close(rf_file_ctx_t* fc);
rf_int_t rf_file_ioctl(rf_file_ctx_t* fc, rf_int_t cmd, rf_void_t* args);
rf_int_t rf_file_lseek(rf_file_ctx_t* fc, rf_off_t offset, rf_int_t origin, rf_off_t* poffset);
rf_int_t rf_file_read(rf_file_ctx_t* fc, rf_void_t* buf, rf_size_t len, rf_size_t* plen);
rf_int_t rf_file_readdir(rf_file_ctx_t* fc, const rf_char_t* pattern, rf_dirent_t* dirp);

rf_int_t rf_file_write(rf_file_ctx_t* fc, const rf_void_t* buf, rf_size_t len, rf_size_t* plen);
rf_int_t rf_file_unlink(const rf_char_t* path);
rf_int_t rf_file_rename(const rf_char_t* oldname, const rf_char_t* newname);

#endif
