/*!The RanFs Library
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Copyright (C) 2014-2019, www.ranfs.com
 *
*/
#ifndef __RF_STREAM_H__
#define __RF_STREAM_H__

#define RF_IOYOURBUF      0x0100
#define RF_IOSETVBUF      0x0400
#define RF_IOFEOF         0x0800
#define RF_IOFLRTN        0x1000
#define RF_IOCTRLZ        0x2000
#define RF_IOCOMMIT       0x4000

#define rf_inuse(s)        ((s)->_flag & (RF_IOREAD|RF_IOWRT|RF_IORW))
#define rf_mbuf(s)         ((s)->_flag & RF_IOMYBUF)
#define rf_nbuf(s)         ((s)->_flag & RF_IONBF)
#define rf_ybuf(s)         ((s)->_flag & RF_IOYOURBUF)
#define rf_bigbuf(s)       ((s)->_flag & (RF_IOMYBUF|RF_IOYOURBUF))
#define rf_anybuf(s)       ((s)->_flag & (RF_IOMYBUF|RF_IONBF|RF_IOYOURBUF))

RF_FILE* rf_get_stream(void);
rf_void_t rf_free_stream(RF_FILE* stream);
rf_void_t rf_getbuf(RF_FILE* str);
rf_int_t rf_filbuf(RF_FILE* str);

extern rf_int_t _rf_nstream;
extern void** __rf_piob;

#endif
